#include <iostream>
#include <fstream>
#include <string.h>
#include <string>
#include "id3frames.h"
#include "id3types.h"

using namespace std;

ID3Frame::ID3Frame (ID3FrameHeader *head, char *fData, unsigned long int dataSize)
{
	_name = string(head->id, 4);
	_size = head->size;
	_flags = head->flags;
	_data = new char[dataSize];
	dSize = dataSize;
	memcpy (_data, fData + 1, dataSize);
}

ID3Frame::ID3Frame (char *fName, unsigned long int fSize, unsigned short int fFlags, char *fData, unsigned long int dataSize)
{
	_name = fName;
	_size = fSize;
	_flags = fFlags;
	_data = new char[dataSize + 1];
	dSize = dataSize;
	memcpy (_data, fData, dataSize + 1);
}

void ID3Frame::save (char *fileName)
{
	// Find the beginning of the JPEG header
	char *i = (char *)memchr (_data, '\xff', dSize);
	int begin = i - _data;
	char *out = new char[dSize - begin];
	memcpy (out, _data + begin, dSize - begin);
	ofstream file(fileName, ios::out | ios::binary);
	file.write(reinterpret_cast<char *>(out), dSize - (begin + 1));
	file.close();
	delete [] out;
}

bool ID3Frame::compare (char *id)
{
	if (!_name.compare (id))
		return true;
	return false;
}