#ifndef _ID3FRAMES_H_
#define _ID3FRAMES_H_

#include <string>
#include "id3types.h"

using namespace std;

class ID3Frame {

public:
	ID3Frame () {}
	ID3Frame (ID3FrameHeader *head, char *fData, unsigned long int dataSize);
	ID3Frame (char *fName, unsigned long int fSize, unsigned short int fFlags, char *fData, unsigned long int dataSize);

	bool compare (char *id);
	void save (char *fileName);

	// Properties
	string name () { return _name; }
	unsigned long int size () { return _size; }
	char *data () { return _data; }
	string toString () { return string (_data, dSize - 1); }

private:

	char *_data;
	unsigned long int dSize;
	string _name;
	unsigned long int _size;
	unsigned short int _flags;

};

#endif