#ifndef ID3LIB_H
#define ID3LIB_H

#include <vector>
#include <string>
#include "id3frames.h"
#include "id3types.h"
using namespace std;

class ID3Lib {

public:
	ID3Lib ();
	ID3Lib (char *fileName);
	~ID3Lib ();
	
	bool operator! () { return !_loaded; }
	
	bool saveAlbumArt (char *fileName);
	string tag (char *id);

	int version () { return _version; }
	string artist () { return tag ("TPE1"); }
	string title () { return tag ("TIT2"); }
	string album () { return tag ("TALB"); }
	string track () { return tag ("TRCK"); }
	string disc () { return tag ("TPOS"); }
	string year () { return tag ("TYER"); }
	string genre () { return tag ("TCON"); }
	unsigned long int length () { return _length; }

private:
	ID3Header fileHead;
	
	// Properties
	int _version;
	bool _loaded;
	unsigned int _length;

	// Objects
	vector<ID3Frame> frames;

	unsigned int LSB (unsigned short int num);
	unsigned int LSB (unsigned long int num);
	unsigned long int calcSize (unsigned long int num);

protected:

};

#endif